<template>
    <table id="datatable-buttons" class="table table-bordered">
        <thead>
            <tr>
                <th>#</th>
                <th>Nombre</th>
                <th>Cursos</th>
                <th>Acciones</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="(item, index) in categoria" :key="item.id">
                <td>{{ index + 1 }}</td>
                <td>{{ item.name }}</td>
                <td>
                    <div
                        class="tabledit-toolbar btn-toolbar"
                        style="text-align: left;"
                    >
                        <div
                            class="btn-group btn-group-sm"
                            style="float: none;"
                        >
                            <!-- <button
                                type="button"
                                class="tabledit-edit-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                v-bind:data-target="'#showModal' + item.id"
                            >
                                <span class="ti-eye"></span>
                            </button> -->
                            {{ item.cursos ? item.cursos.length : 0 }} Cursos
                            asignados
                        </div>
                    </div>
                </td>
                <td>
                    <div
                        class="tabledit-toolbar btn-toolbar"
                        style="text-align: left;"
                    >
                        <div
                            class="btn-group btn-group-sm"
                            style="float: none;"
                        >
                            <button
                                type="button"
                                class="tabledit-edit-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                :data-target="'#editModal' + item.id"
                            >
                                <span class="ti-pencil"></span></button
                            ><button
                                v-if="item.cursos.length == 0"
                                type="button"
                                class="tabledit-delete-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                :data-target="'#deleteModal' + item.id"
                            >
                                <span class="ti-trash"></span>
                            </button>
                            <button
                                v-if="item.cursos.length != 0"
                                type="button"
                                class="btn btn-sm btn-warning"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                :data-target="'#alertModal' + item.id"
                            >
                                <span class="ti-alert"></span>
                            </button>
                        </div>
                    </div>
                </td>
                <!-- editar categoría -->
                <div
                    class="modal fade"
                    :id="'editModal' + item.id"
                    tabindex="-1"
                    role="dialog"
                    aria-labelledby="crearModalLabel"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="crearModalLabel">
                                    Editar categoría
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form
                                    method="POST"
                                    @submit.prevent="edit(item)"
                                >
                                    <!-- Alerta de error -->
                                    <div
                                        v-if="error"
                                        id="errorAlert"
                                        class="alert alert-danger alert-dismissible fade show"
                                        role="alert"
                                    >
                                        <strong>Ohh no!</strong> {{ error }}.
                                        <button
                                            type="button"
                                            class="close"
                                            v-on:click.prevent="closeAlert()"
                                            aria-label="Close"
                                        >
                                            <span aria-hidden="true"
                                                >&times;</span
                                            >
                                        </button>
                                    </div>
                                    <!-- fin de error -->
                                    <div class="form-group">
                                        <input
                                            type="text"
                                            placeholder="Ingrese el nombre de la categoría"
                                            class="form-control "
                                            name="category"
                                            v-model="item.name"
                                            required
                                            autocomplete="category"
                                            autofocus
                                        />
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-secondary"
                                    data-dismiss="modal"
                                >
                                    Cerrar
                                </button>
                                <button
                                    v-on:click.prevent="edit(item)"
                                    type="button"
                                    class="btn btn-primary"
                                >
                                    Guardar
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- fin editar categoría  -->
                <!-- Alerta -->
                <div
                    class="modal fade"
                    v-bind:id="'alertModal' + item.id"
                    tabindex="-1"
                    role="dialog"
                    v-bind:aria-labelledby="'deleteModalLabel' + item.id"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header bg-warning">
                                <h5
                                    class="modal-title text-black"
                                    v-bind:id="'alertModalLabel' + item.id"
                                >
                                    ¡No puede realizar esta acción!
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <p class="text-muted">
                                    No puede eliminar la categoria
                                    {{ item.name }} ya que tiene asignado
                                    {{ item.cursos ? item.cursos.length : 0 }}
                                    cursos. <br />
                                    Para poder eliminarla primero debe editar
                                    los cursos asignados y agregarles una nueva
                                    categoría.
                                </p>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-warning text-black"
                                    data-dismiss="modal"
                                >
                                    Continuar
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- fin alerta -->
                <!-- eliminar -->
                <div
                    class="modal fade"
                    v-bind:id="'deleteModal' + item.id"
                    tabindex="-1"
                    role="dialog"
                    v-bind:aria-labelledby="'deleteModalLabel' + item.id"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header bg-danger">
                                <h5
                                    class="modal-title "
                                    v-bind:id="'deleteModalLabel' + item.id"
                                >
                                    Eliminar disponibilidad
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <p class="text-muted">
                                    ¿Seguro desea eliminar la disponibilidad del
                                    curso {{ item.name }}?
                                </p>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-secondary"
                                    data-dismiss="modal"
                                >
                                    Cancelar
                                </button>
                                <button
                                    type="button"
                                    class="btn btn-danger"
                                    v-on:click.prevent="deleteCat(item.id)"
                                >
                                    Eliminar categoría
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- fin eliminar -->
            </tr>
        </tbody>
        <!-- agegar categoría -->
        <div
            class="modal fade"
            id="crearModal"
            tabindex="-1"
            role="dialog"
            aria-labelledby="crearModalLabel"
            aria-hidden="true"
        >
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="crearModalLabel">
                            Agregar nueva categoría
                        </h5>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                            aria-label="Close"
                        >
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form method="POST" @submit.prevent="create">
                            <!-- Alerta de error -->
                            <div
                                v-if="error"
                                id="errorAlert"
                                class="alert alert-danger alert-dismissible fade show"
                                role="alert"
                            >
                                <strong>Ohh no!</strong> {{ error }}.
                                <button
                                    type="button"
                                    class="close"
                                    v-on:click.prevent="closeAlert()"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <!-- fin de error -->
                            <div class="form-group">
                                <input
                                    type="text"
                                    placeholder="Ingrese el nombre de la categoría"
                                    class="form-control "
                                    name="category"
                                    v-model="newCategory.name"
                                    required
                                    autocomplete="category"
                                    autofocus
                                />
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button
                            type="button"
                            class="btn btn-secondary"
                            data-dismiss="modal"
                        >
                            Cerrar
                        </button>
                        <button
                            v-on:click.prevent="create()"
                            type="button"
                            class="btn btn-primary"
                        >
                            Crear categoría
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <!-- fin agrgar categoría  -->
    </table>
</template>

<script>
export default {
    created() {
        this.get();
    },
    mounted() {},
    data() {
        return {
            categoria: [],
            error: "",
            newCategory: {
                name: ""
            }
        };
    },
    methods: {
        seturl: () => {},
        get() {
            var url = "/api/cursos/category";
            axios
                .get(url)
                .then(res => {
                    this.categoria = res.data;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        create() {
            var url = "/api/cursos/category";
            axios
                .post(url, this.newCategory)
                .then(res => {
                    if (res.data.error) {
                        this.error = res.data.error;
                    } else {
                        $("#crearModal").modal("toggle");
                        $(".modal-backdrop").remove();
                        this.get();
                    }
                })
                .catch(err => {
                    console.log(err);
                });
        },
        edit(i) {
            var url = "/api/cursos/category/" + i.id;
            axios
                .put(url, i)
                .then(res => {
                    if (res.data.error) {
                        this.error = res.data.error;
                    } else {
                        $("#editModal" + i.id).modal("toggle");
                        $(".modal-backdrop").remove();
                        this.get();
                    }
                })
                .catch(err => {
                    console.log(err);
                });
        },
        deleteCat(item) {
            var url = "/api/cursos/category/" + item;
            axios
                .delete(url)
                .then(res => {
                    $("#deleteModal" + item).modal("toggle");
                    $(".modal-backdrop").remove();
                    this.get();
                })
                .catch(err => {
                    console.log(err);
                });
        },

        closeAlert() {
            this.error = "";
        }
    }
};
</script>
